# == Schema Information
#
# Table name: message_templates
#
#  id               :integer          not null, primary key
#  type             :string(255)
#  sys_notice       :text(65535)
#  email            :text(65535)
#  created_at       :datetime         not null
#  updated_at       :datetime         not null
#  notification_url :string(255)
#  email_title      :string(255)
#

# 我创建或负责的疑修截止日期到达最后一天
class MessageTemplate::IssueExpire < MessageTemplate

  # MessageTemplate::IssueCreatorExpire.get_message_content(User.where(login: 'yystopf'), Issue.last)
  def self.get_message_content(receivers, issue)
    receivers.each do |receiver|
      if receiver.user_template_message_setting.present? 
        send_setting = receiver.user_template_message_setting.notification_body["CreateOrAssign::IssueExpire"]
        send_setting = send_setting.nil? ? UserTemplateMessageSetting.init_notification_body["CreateOrAssign::IssueExpire"] : send_setting
        receivers = receivers.where.not(id: receiver.id) unless send_setting
      end
    end
    return '', '', '' if receivers.blank?
    project = issue&.project
    owner = project&.owner
    content = sys_notice.gsub('{title}', issue&.subject)
    url = notification_url.gsub('{owner}', owner&.login).gsub('{identifier}', project&.identifier).gsub('{id}', issue&.project_issues_index.to_s)

    return receivers_string(receivers), content, url
  rescue => e
    Rails.logger.info("MessageTemplate::IssueExpire.get_message_content [ERROR] #{e}")
    return '', '', ''
  end

  def self.get_email_message_content(receiver, issue)
    if receiver.user_template_message_setting.present? 
      send_setting = receiver.user_template_message_setting.email_body["CreateOrAssign::IssueExpire"]
      send_setting = send_setting.nil? ? UserTemplateMessageSetting.init_email_body["CreateOrAssign::IssueExpire"] : send_setting
      return '', '', '' unless send_setting
      project = issue&.project
      owner = project&.owner 
      title = email_title

      content = email
      content.gsub!('{receiver}', receiver&.real_name)
      content.gsub!('{nickname}', owner&.real_name)
      content.gsub!('{login}', owner&.login)
      content.gsub!('{identifier}', project&.identifier)
      content.gsub!('{repository}', project&.name)
      content.gsub!('{baseurl}', base_url)
      content.gsub!('{title}', issue&.subject)
      content.gsub!('{id}', issue&.project_issues_index.to_s)
      content.gsub!('{platform}', PLATFORM)
  
      return receiver&.mail, title, content
    else
      return '', '', ''
    end
  rescue => e
    Rails.logger.info("MessageTemplate::IssueExpire.get_email_message_content [ERROR] #{e}")
    return '', '', ''
  end
end
